module half_adder(
    input  a,
    input  b,
    output sum,
    output cout
) ;
    assign sum  = a ^ b ;
    assign cout = a & b ;
endmodule : half_adder

module full_adder(
    input  a,
    input  b,
    input  cin,
    output sum,
    output cout
) ;
    assign { cout, sum } = a + b + cin ;
endmodule : full_adder

module add4bit (
    input  [3:0] a,
    input  [3:0] b,
    output [3:0] sum,
    output       cout
) ;

// NOTE: This also could be 
//  assign { cout, sum } = { 1'b0, a } + { 1'b0, b } ;

    logic [2:0] c ;

    half_adder ha_1 (.a(a[0]), .b(b[0]),             .sum(sum[0]), .cout(c[0])) ;

    full_adder fa_1 (.a(a[1]), .b(b[1]), .cin(c[0]), .sum(sum[1]), .cout(c[1])) ;

    full_adder fa_2 (.a(a[2]), .b(b[2]), .cin(c[1]), .sum(sum[2]), .cout(c[2])) ;

    full_adder fa_3 (.a(a[3]), .b(b[3]), .cin(c[2]), .sum(sum[3]), .cout(cout)) ;

endmodule : add4bit

`default_nettype wire
