module test_add4bit (
    input        clk,
    input  [3:0] a,
    input  [3:0] b,
    output [7:0] seg,
    output [3:0] dig
) ;
    parameter MAX160HZ = 26'd168749 ;
    logic [3:0]      sum ;
    logic            c   ;
    logic [3:0][7:0] seg_in ;
    logic            clk_160hz ;

    clkdiv  clkdiv_1 (.*, .nrst(1'b1), .max(MAX160HZ), .clk_out(clk_160hz), .tc()) ;

    add4bit add4bit_1 (.*, .cout(c)) ;

    drv7seg drv7seg_1 (.in(a),         .dp(1'b0), .seg(seg_in[3])) ;
    drv7seg drv7seg_2 (.in(b),         .dp(1'b0), .seg(seg_in[2])) ;
    drv7seg drv7seg_3 (.in({3'b0, c}), .dp(1'b0), .seg(seg_in[1])) ;
    drv7seg drv7seg_4 (.in(sum),       .dp(1'b0), .seg(seg_in[0])) ;

    mux7seg mux7seg_1 (
        .*,
        .nrst(1'b1),
        .clk(clk_160hz)
    ) ;

endmodule : test_add4bit
