/*****************
 * leg4asm.c
 ****************/

#include <stdio.h>
#include <string.h>
#include <stdlib.h>

#include "leg4utils.h"
#include "leg4.h"
#include "leg4asm.h"

FILE *ifp ;
FILE *ofp ;
int gAddress = 0 ;
int gLineNo = 0 ;

int main(int argc, char *argv[])
{
	getOpt(argc, argv) ;
	doIt() ;
	cleanUp() ;
	return(0) ;
}

void getOpt(int argc, char *argv[])
{
    if ((argc > 1)&&(strcmp(argv[1], "-"))) {
        ifp = efopen(argv[1], "r") ;
    } else {
        ifp = stdin ;
    }
    if ((argc > 2)&&(strcmp(argv[2], "-"))) {
        ofp = efopen(argv[2], "w") ;
    } else {
        ofp = stdout ;
    }
}

void cleanUp() 
{
	fclose(ifp) ;
	fclose(ofp) ;
}

void writeAddress()
{
	fprintf(ofp, "%01X: ", gAddress ) ;
}

int incAddress()
{
	gAddress++ ;
	return( gAddress ) ;
}

void writeMifHeader(FILE *ofp)
{
	fprintf(ofp, "DEPTH = 16 ;\n") ;
	fprintf(ofp, "WIDTH = 8 ;\n") ;
	fprintf(ofp, "ADDRESS_RADIX = HEX ;\n") ;
	fprintf(ofp, "DATA_RADIX = HEX ;\n") ;
	fprintf(ofp, "CONTENT\n") ;
	fprintf(ofp, "BEGIN\n") ;
}

void writeMifTailer(FILE *ofp)
{
	int adr ;
	for (adr = gAddress ; adr < 0x10 ; adr++ ) {
		fprintf(ofp, "%0X: 00 ;\n", adr) ;
	}
	fprintf(ofp, "END ;\n") ;
}

void doIt()
{
	char command[256] ;
	FuncPtrType func ;

	writeMifHeader(ofp) ;

	while(fscanf(ifp, "%s", command) != EOF) {
		gLineNo++ ;
		if (*command != '!') {
			str2upper(command) ;
			func = getFunc(command) ;
			if (func != 0) {
				writeAddress() ;
				func() ;
				incAddress() ;
			} else {
				fprintf(stderr, "Syntax Error at %d : %s\n", gLineNo, command) ;
				exit( 9 ) ;
			}
		}
		skipToEOL(ifp) ;	
		fprintf(ofp, "\n") ;
	}

	writeMifTailer(ofp) ;
}
