/****************
 * leg4utils.c
 ***************/

#include <stdio.h>
#include <string.h>
#include <stdlib.h>

#include "leg4utils.h"

FILE *efopen(char *filename, char *mode)
{
	FILE *fp ;
	fp = fopen(filename, mode) ;
	if (fp == NULL) {
		fprintf(stderr, "Can not open %s\n", filename) ;
		exit( 3 ) ;
	}
	return( fp ) ;
}

int skipToEOL(FILE *ifp)
{
	int c ;
	while((c = fgetc(ifp)) != EOF) {
		if ( c == '\n' ) {
			break ;
		}
	}
	return( c ) ;
}

int dupToEOL(FILE *ifp, FILE *ofp) 
{
	int c ;
	while((c = fgetc(ifp)) != EOF) {
		if ( c == '\n' ) {
			break ;
		} else {
			fputc(c, ofp) ;
		}
	}
	return( c ) ;
}

int skipTo(FILE *ifp, int target)
{
	int c ;
	while((c = fgetc(ifp)) != EOF) {
		if (c == target) {
			break ;
		}
	}
	return( c ) ;
}

int dupTo(FILE *ifp, FILE *ofp, int target)
{
	int c ;
	while((c = fgetc(ifp)) != EOF) {
		if (c == target) {
			break ;
		} else {
			fputc(c, ofp) ;
		}
	}
	return( c ) ;
}

void str2upper(char *str)
{
	char *ptr = str ;
	while((ptr != 0)&&(*ptr != 0)) {
		if ((*ptr >= 'a')&&(*ptr <= 'z')) {
			*ptr -= ('a' - 'A') ;
		}
		ptr++ ;
	}
}

int b2i(char *str)
{
	int value = 0 ;
	int i = 0 ;
	char *ptr = str ;

	while((ptr != 0)&&(*ptr != 0)&&(i < WORD_SIZE)) {
		value <<= 1 ;
		i++ ;
		switch(*ptr) {
		case '0':
			break ;
		case '1':
			value += 1 ;
			break ;
		default:
			fprintf(stderr, "Invalid BIN string [ %s ]\n", str) ;
			exit( 5 ) ;
		}
		ptr++ ;
	}
	return( value ) ;
}

char *i2b(int value)
{
	static char str[32] ;
	int mask = 0x01 << (WORD_SIZE - 1) ;
	int i = 0 ;

	while( mask != 0) {
		if (value & mask) {
			str[i] = '1' ;
		} else {
			str[i] = '0' ;
		}
		mask >>= 1 ;
		i++ ;
	}
	str[i] = (char)0 ;
	return( str ) ;
}
