// leg4.v
// LEG4 (Logically Elegant Gene 4bit)

module leg4 (
    input              clk,
    input              nrst,
    input        [7:0] mem,
    input        [3:0] in,
    output logic [3:0] a, b, out,
    output logic       co,
    output logic [3:0] adr
) ;

    logic [3:0] in_r ;
    logic [3:0] data ;
    logic       wa, wb, wo, jump ;
    logic       alu_co ;

    always_ff @(negedge nrst or posedge clk) begin
        if (nrst == 1'b0) begin
            a    <= 4'd0 ;
            b    <= 4'd0 ;
            out  <= 4'd0 ;
            co   <= 1'd0 ;
            in_r <= 4'd0 ;
        end else begin
            if (wa == 1'b1) a   <= data ; else a   <= a ; 
            if (wb == 1'b1) b   <= data ; else b   <= b ;
            if (wo == 1'b1) out <= data ; else out <= out ;
            co <= alu_co ;
            in_r <= in ;
        end // if (nrst == 1'b0)
    end // always

    pc  inst1 (.*, .in(data)) ;

    alu inst2 (
        .*,              // .nrst, .a, .b, .wa, .wb, .wo, .jump, .data
        .cmd(mem[7:4]),
        .ci(co),
        .imd(mem[3:0]),
        .in(in_r),
        .co(alu_co)
    ) ;

endmodule : leg4