// pc.v
// program counter for LEG4

module pc (
    input              clk,
    input              nrst,
    input              jump,
    input        [3:0] in,
    output logic [3:0] adr
) ;

    always_ff @(negedge nrst or posedge clk) begin
        if (nrst == 1'b0) begin
            adr <= 4'h0 ;
        end else begin
            if (jump) begin
                adr <= in ;
            end else begin
                adr <= adr + 4'd1 ;
            end // if (jump)
        end // if (nrst == 1'b0)
    end // always
endmodule : pc
