/*
 * matrix_key
 * As we use ts[7:0] for row[3:0] and col[3:0]
 * We need to set all ts[7:0] to high position
 */
module test_matrix_key (
    input              clk, 
    input              nrst,
    input        [3:0] row,
    output logic [3:0] col,
    output logic [7:0] seg,
    output logic [3:0] dig,
    output logic       ready ) ;

    logic [15:0]  key     ;
    logic [3:0]   value   ;
    logic         clk50hz ;
    logic         dp      ;

    parameter max50hz = 26'd539999 ; /* 27000000 / 50 = 540000 */

    assign dig = 4'b1110 ;

    clkdiv clkdiv_1 (.*, .max(max50hz), .clk_out(clk50hz), .tc()) ;

    matrix_key matrix_key_1 (.*, .clk(clk50hz), .tc(ready)) ;

    dec16to4 dec16to4_1 (.*, .out(value), .pushed(dp)) ;

    drv7seg drv7seg_1 (.*, .in(value)) ;

endmodule : test_matrix_key
