module dec_led (
    input  [3:0] in,
    output [7:0] led
) ;

    function [7:0] decode ;
        input [3:0] in ;
        begin
            case (in)
            4'h0: decode = 8'b1111_1111 ;
            4'h1: decode = 8'b1111_1110 ;
            4'h2: decode = 8'b1111_1100 ;
            4'h3: decode = 8'b1111_1000 ;
            4'h4: decode = 8'b1111_0000 ;
            4'h5: decode = 8'b1110_0000 ;
            4'h6: decode = 8'b1100_0000 ;
            4'h7: decode = 8'b1000_0000 ;
            4'h8: decode = 8'b0000_0000 ;
            default:
                decode = {4'b0101, ~in} ;
            endcase
        end
    endfunction

    assign led = decode(in) ;

endmodule // dec_led

`default_nettype wire
