module decdiv (
    input        [3:0] sw,
    output logic [16:0] count
) ;

    function [16:0] decode ;
        input [3:0] sw ;
        case (sw)
        'h0: decode = 'd77535 ; /* F */
        'h1: decode = 'd69055 ; /* G */
        'h2: decode = 'd61503 ; /* A */
        'h3: decode = 'd54780 ; /* B */
        'h4: decode = 'd51699 ; /* C */
        'h5: decode = 'd46049 ; /* D */
        'h6: decode = 'd41018 ; /* E */
        'h7: decode = 'd38712 ; /* F */
        'h8: decode = 'd34482 ; /* G */
        'h9: decode = 'd30717 ; /* A */
        'hA: decode = 'd27362 ; /* B */
        'hB: decode = 'd25825 ; /* C */
        'hC: decode = 'd23005 ; /* D */
        'hD: decode = 'd20493 ; /* E */
        'hE: decode = 'd19342 ; /* F */
        'hF: decode = 'd17231 ; /* G */
        endcase
    endfunction : decode

    assign count = decode(sw) ;

endmodule : decdiv
