module organ (
    input              nrst,
    input              clk,
    input        [3:0] row,
    output logic [3:0] col,
    output logic       bz,
    output logic [7:0] seg,
    output logic [3:0] dig,
    output logic       ready
) ;

    parameter MAX50HZ = 26'd539999 ; /* 27MHz / 50Hz = 540000 */

    logic [15:0] key ;
    logic [16:0] count ;
    logic  [3:0] sw ;
    logic        dot, tone ;
    logic        clk50hz ;

    assign dig = 4'b1110 ; 

    assign bz = tone & dot ;

    clkdiv clkdiv_1 (.*, .max(MAX50HZ), .clk_out(clk50hz), .tc()) ;

    matrix_key inst2 (.*, .clk(clk50hz), .tc(ready)) ;

    dec16to4 inst3 (.key(key), .out(sw), .pushed(dot)) ;

    decdiv inst4 (.sw(sw), .count(count)) ;

    clkdiv inst5 (.*, .max({9'b0, count}), .clk_out(tone), .tc()) ;

    drv7seg inst7 (.in(sw), .dp(dot), .seg(seg)) ;

endmodule : organ
