module cntr4maxe (
    input              clk, 
    input              nrst, 
    input              en, 
    input              up,
    input        [3:0] max,
    output logic [3:0] cnt,
    output logic       tc 
) ;

    logic reach, active ;

    always_ff @(negedge nrst or posedge clk) begin
        if (nrst == 1'b0) begin
            cnt <= 4'd0 ;
        end else begin
            if (active == 1'b1) begin
                if (tc == 1'b1)
                    cnt <= 4'd0 ;
                else
                    cnt <= cnt + 4'd1 ;
            end else
                cnt <= cnt ;
        end
    end /* always */

    assign reach  = (cnt >= max) ;
    assign active = (en == 1'b1) && (up == 1'b1) ;
    assign tc     = active && reach ;

endmodule : cntr4maxe
