module cntr4max (
    input              clk, 
    input              nrst, 
    input              up,
    input        [3:0] max,
    output logic [3:0] cnt,
    output logic       tc 
) ;

    assign tc = up & (cnt >= max) ;

    always_ff @(negedge nrst or posedge clk) begin
        if (nrst == 1'b0) 
            cnt <= 4'd0 ;
        else begin
            if (up == 1'b1) begin
                if (tc == 1'b1) 
                    cnt <= 4'd0 ;
                else 
                    cnt <= cnt + 4'd1 ;
            end else begin
                cnt <= cnt ;
            end
        end 
    end // always

endmodule : cntr4max
