module run_led(
    input              nrst,
    input              clk,
    input              en,
    input              up,
    input        [1:0] tsw,
    output logic [7:0] led
) ;

    parameter LED_OFF = 8'b1111_1111 ;

    logic [2:0] count ;

    function [7:0] pattern0 ;
        input [2:0] count ;
        begin
            case (count)
            3'h0: pattern0 = 8'b1111_1110 ;
            3'h1: pattern0 = 8'b1111_1101 ; 
            3'h2: pattern0 = 8'b1111_1011 ;
            3'h3: pattern0 = 8'b1111_0111 ; 
            3'h4: pattern0 = 8'b1110_1111 ;
            3'h5: pattern0 = 8'b1101_1111 ; 
            3'h6: pattern0 = 8'b1011_1111 ;
            3'h7: pattern0 = 8'b0111_1111 ; 
            endcase
        end
    endfunction

    function [7:0] pattern1 ;
        input [2:0] count ;
        begin
            case (count)
            3'h0: pattern1 = 8'b0111_1111 ;
            3'h1: pattern1 = 8'b1011_1111 ; 
            3'h2: pattern1 = 8'b1101_1111 ;
            3'h3: pattern1 = 8'b1110_1111 ; 
            3'h4: pattern1 = 8'b1111_0111 ;
            3'h5: pattern1 = 8'b1111_1011 ; 
            3'h6: pattern1 = 8'b1111_1101 ;
            3'h7: pattern1 = 8'b1111_1110 ; 
        endcase
        end
    endfunction

    function [7:0] pattern2 ;
        input [2:0] count ;
        begin
            case (count)
            3'h0: pattern2 = 8'b1111_1110 ;
            3'h1: pattern2 = 8'b1111_1100 ; 
            3'h2: pattern2 = 8'b1111_1000 ;
            3'h3: pattern2 = 8'b1111_0001 ; 
            3'h4: pattern2 = 8'b1110_0011 ;
            3'h5: pattern2 = 8'b1100_0111 ; 
            3'h6: pattern2 = 8'b1000_1111 ;
            3'h7: pattern2 = 8'b0001_1111 ; 
            endcase
        end
    endfunction

    function [7:0] pattern3 ;
        input [2:0] count ;
        begin
            case (count)
            3'h0: pattern3 = 8'b0111_1111 ;
            3'h1: pattern3 = 8'b0011_1111 ; 
            3'h2: pattern3 = 8'b0001_1111 ;
            3'h3: pattern3 = 8'b1000_1111 ; 
            3'h4: pattern3 = 8'b1100_0111 ;
            3'h5: pattern3 = 8'b1110_0011 ; 
            3'h6: pattern3 = 8'b1111_0001 ;
            3'h7: pattern3 = 8'b1111_1000 ; 
        endcase
        end
    endfunction

    always @(negedge nrst or posedge clk) begin
        if (nrst == 1'b0) begin
            led   <= LED_OFF ;
            count <= 3'd0 ;
        end else begin
            if (en && up) begin
                count <= count + 3'd1 ;
                case (tsw)
                2'd0: led <= pattern0( count ) ;
                2'd1: led <= pattern1( count ) ;
                2'd2: led <= pattern2( count ) ;
                2'd3: led <= pattern3( count ) ;
                endcase
            end
        end
    end

endmodule : run_led
