module debounce (
    input        clk,
    input        nrst,
    input        key_in,
    output logic key_out
) ;
    logic [3:0] key_n ;

    always_ff @(negedge nrst or posedge clk) begin
        if (nrst == 1'b0) begin
            key_n <= 4'b1111 ;
        end else begin
            key_out  <= |key_n   ;
            key_n[3] <= key_n[2] ;
            key_n[2] <= key_n[1] ;
            key_n[1] <= key_n[0] ;
            key_n[0] <= key_in   ;
        end
    end /* always */

endmodule : debounce 
