module toggle (
    input        clk, 
    input        nrst, 
    input        in,
    output logic out ) ;

    logic prev_in ;

    always_ff @(negedge nrst or posedge clk) begin
        if (nrst == 1'b0) begin
            out     <= 1'b0 ;
            prev_in <= 1'b0 ;
        end else begin
            prev_in <= in ; 
            if ({prev_in, in} == 2'b10)
                out <= ~out ;
            else
                out <= out ;
        end
    end

endmodule : toggle
